/*
video related defines
*/
#ifndef VIDEO_DEFINES_H
#define VIDEO_DEFINES_H

#define DISPCNT_A 0x4000000
#define DISPCNT_B 0x4001000

#define OAM_A			0x7000000
#define OAM_B			0x7000400

#define BG_VIDMODE_0	0x0
#define BG_VIDMODE_1	0x1
#define BG_VIDMODE_2	0x2
#define BG_VIDMODE_3	0x3
#define BG_VIDMODE_4	0x4
#define BG_VIDMODE_5	0x5

#define DISPLAY_GFX		(1<<16)

#define OBJ_ENABLE		(1<<12)
#define OBJ_MAP_1D		(1<<4)
#define OBJ_MAP_2D		(0<<4)
	
#define OBJ_BOUND_32	(0<<20)
#define OBJ_BOUND_64	(1<<20)
#define OBJ_BOUND_128	(2<<20)	
#define OBJ_BOUND_256	(3<<20)

#define STD_BGa_PAL		0x5000000
#define STD_OBJa_PAL	0x5000200
#define STD_BGb_PAL		0x5000400
#define STD_OBJb_PAL	0x5000600

#define VRAM_A_CNT		0x4000240
#define VRAM_B_CNT		0x4000241
#define VRAM_C_CNT		0x4000242
#define VRAM_D_CNT		0x4000243
#define VRAM_E_CNT		0x4000244
#define VRAM_F_CNT		0x4000245
#define VRAM_G_CNT		0x4000246
#define VRAM_H_CNT		0x4000247
#define VRAM_I_CNT		0x4000248
#define VRAM_J_CNT		0x4000249

#define VRAM_ENABLE		(1<<7)
#define VRAMOFF_1		(1<<3)
#define VRAMOFF_2		(2<<3)
#define VRAMOFF_3		(3<<3)
/*
The pointers to OBJVRAM can be changed for bank A,B,F en G
This is done by putting VRAM_OFF1(only valid)
in the VRAM_X_CNT register
*/
#define A_OBJVRAM		2
#define E_OBJVRAM		2
#define F_OBJ_VRAM	2
#define G_OBJVRAM		2

#define A_BGVRAM    1
#endif
