/*
Background related functions

Copyright 2010, 2011 Tomwi

typedef struct BG_INF{
void * tiles;		// tiles in ram (tileset)
void * map;			// map in ram (complete, not scattered as in vram:))
void * vram_map;	// Pointer to the BEGIN of the 2 screenbases needed for dynamic scrolling
int mapwidth;
}BG_INF;

*/

	.text
	
@*********************************************************************************	
	.global fillScreen
@*********************************************************************************
	.align 1
	.thumb_func
	
@---------------------------------------------------------------------------------
@ A function which will fill the visible part of the screen while taking the 
@ the given position of the map into account
@ r0 = bgInf * ptr 
@ r1 = tilex
@ r2 = tiley
@---------------------------------------------------------------------------------
fillScreen:


	push {lr}
	push {r4-r7}

	mov	r5, r0
	mov	r6, r1
	mov	r7, r2
	mov	r4, #32

.Loop:
	
	mov	r0, r5
	add	r1, r6, r4
	mov r2, r7

	bl t_copyColumn
	sub	r4, r4, #1
	bpl	.Loop
	
	pop {r4-r7}
	pop {r3}
	bx r3
	
	
@*********************************************************************************
	.global t_copyRow
@*********************************************************************************
	.align 2
	.arm
@---------------------------------------------------------------------------------
@ This function will draw a row of 33 tiles taking the given position of
@ the map into account
@ r0 = bginf
@ r1 = tilex
@ r2 = tiley
@---------------------------------------------------------------------------------
t_copyRow:

	stmfd	sp!, {r4}				
	
	ldr		r3,[r0, #4]				@ src
	ldr 	r4,[r0, #12]			@ mapwidth
	ldr		r0,[r0, #8]				@ dst
	
	lsl		ip, r1, #6				 
	
	@ calculate src starting index
	mla		r1, r2, r4, r1			
	add		r1, r3, r1, lsl #1		
	
	@ calculate "base index" of the screenblock
	mov		r2, r2, lsl #27			
	add		r0, r0, r2, lsr #(26-5)	
	
	mov		r2, #33
	
.rowloop:

	ldrh	r3, [r1], #2
	and 	r4, ip, #(1<<11)
	orr 	r3, ip, lsl #21
	orr		r4, r4, r3, lsr #26		
	strh	r3, [r0, r4]			
	
	add		ip, ip, # (1 << 6)		
	subs	r2, r2, #1
	bne		.rowloop
		
	ldmfd	sp!, {r4}
	bx		lr


	
@*********************************************************************************
	.global t_copyColumn
@*********************************************************************************
	.align 2
	.arm
@---------------------------------------------------------------------------------
@ This function will draw a column of 25 tiles taking the given position of
@ the map into account
@ r0 = bginf
@ r1 = tilex
@ r2 = tiley
@---------------------------------------------------------------------------------
t_copyColumn:

	stmfd	sp!, {r4}		
	
	ldr		r3, [r0, #4]			@ tileMap
	ldr		ip, [r0, #12]			@ mapWidth
	ldr		r0, [r0, #8]			@ screenBase	
	
  @ src pointer
	mla		r4, r2, ip, r1		
	add		r3, r3, r4, lsl #1		
	
	movs	r1, r1, lsl #27		
	add		r0, r0, r1, lsr #26		
	addcs	r0, r0, #0x800			
	mov		r2, r2, lsl #27			
	
	
	mov		r4, #25							
	mov		r2, r2, lsr #(21)				
	mov		ip, ip, lsl #1					
	
.columnLoop:

	ldrh	r1, [r3], ip				
	and		r2, r2, #(31<<(5+1))			
	strh	r1, [r0, r2]
	
	add		r2, r2, #1<<(5+1)			
	subs	r4, r4, #1
	bne		.columnLoop
	
	ldmfd	sp!, {r4}
	bx lr
	



