/*
Initialiserings functies
*/
#include "../include/video.h"
#include "../include/dma.h"
#include "../include/sprite_def.h"
#include "../include/background.h"

#include "../build/sprite.h"
#include "../build/background.h" 

	.text
@*********************************************************************************
	.global initVideo
@*********************************************************************************
	.align 1
	.thumb_func
@---------------------------------------------------------------------------------
@ Init sprites and backgrounds
@---------------------------------------------------------------------------------
initVideo:

	push {lr}
	
	ldr r0,=DISPCNT_A
	ldr r1,=DISPLAY_GFX | BG_VIDMODE_0 | OBJ_ENABLE | OBJ_MAP_1D | OBJ_BOUND_128 | 1<<8
	str r1,[r0]
	
	ldr r0,=VRAM_E_CNT
	ldr r1,=VRAM_ENABLE | E_OBJVRAM 
	str r1,[r0]
	
	ldr r0,=VRAM_A_CNT
	ldr r1,=VRAM_ENABLE | A_BGVRAM 
	str r1,[r0]
	
	bl initOam
	ldr r0,=spritePal
	ldr r1,=STD_OBJa_PAL
	ldr r2,=spritePalLen
	ldr r3,=DMA_3_SRC	
	bl copyDmaWords
	
	
	ldr r0,=spriteTiles
	ldr	r1,=0x6400000
	ldr r2,=spriteTilesLen
	sub r3, #8
	bl copyDmaWords
	
	ldr r0,=OAM_A
	ldr r1,=OBJ_16x16 | OBJ_256Kleur
	mov r2, #0xFF
	bic r1, r2		@ extract size and shape attributes
	ldr r2,=(120)	
	orr r1, r2
	str r1, [r0] 	

	
	ldr r0,=backgroundPal
	ldr r1,=STD_BGa_PAL
	ldr r2,=backgroundPalLen
	ldr r3,=DMA_3_SRC
	bl copyDmaWords
	
	ldr r0,=backgroundTiles
	ldr r1,=0x6000000
	ldr r2,=backgroundTilesLen
	sub r3,#8
	bl copyDmaWords
	
	ldr r0,=BG_A0_CNT
	ldr r1,=tBG_512x256 | BG_256C | (4<<9)  @ screenbase 2
	str r1,[r0]
	
	ldr r0,=level0
	mov r1,#0x0
	mov r2,#0x0
	bl fillScreen
	
	pop {pc}


@*********************************************************************************  
  .data
@*********************************************************************************

  .align 2
  .global sprMario

sprMario:
	.word spriteTiles, 0x6400000
	.hword 0x0, 0x0
	.byte 0x0, 0x0, 0x0, (OBJ_16x16 & 0xFF), 0x0

  .align 2
  .global level0
  
level0:
  .word backgroundTiles, backgroundMap, 0x6004000, 0xc8,  colMap
  
  .align 2
  .global scrollPos

scrollPos:
	.hword 0x0, 0x0    @ x, y
	
  .align 2
  .global characterInf  
characterInf:	
	.byte 0x78          @ y

