@ UPDATE routines
#include "../include/input.h"
#include "../include/background.h"
#include "../include/video.h"

	.text
@*********************************************************************************
	.global UpdateGame
@*********************************************************************************	
	.align 2
	.arm
	
UpdateGame:

	push {lr}
  
	bl swiWaitforVblank
	bl readKeyReg
	bl handleKeys
	bl updateScroll
	bl checkCollision
	pop {lr}
	bx lr

  .global updateScroll
  
.align 2
.arm

updateScroll:

push {r4, lr}

  ldr   r2,=scrollPos
  ldr   r0,=level0
  ldrh  r1,[r2]       @ x
  ldr   r3,[r0, #12]  @ width
  
  
  add   r4, r1, #3
  lsr   r1, #3
  add   r2, r1, #32
  cmp   r2, r3
  bge .updateEnd
  cmp   r1, r4, lsr #3
  
  beq   .endScroll     @ no further action needed
  add   r1, #33        
  mov   r2, #0
  bl    t_copyColumn
  
.endScroll:
  ldr   r0,=BG0_HOFS_A
  ldr   r2,=scrollPos
  strh  r4, [r0]        @ store x in register
  strh  r4, [r2]        @ store x in struct

.exit:

pop {r4, lr}

bx lr

.updateEnd:
ldr   r2,=scrollPos
ldr r0,=OAM_A
strh  r4, [r2]        @ store x in struct
ldrh  r1, [r0, #2]
add r1, r1, #3
strh  r1, [r0, #2]
b .exit

@*********************************************************************************
  .global handleKeys
  @ r0 = KEY_INPUT(new)
  @ r1 = KEY_INPUT(old)
@*********************************************************************************
  .align 2
  .arm

handleKeys:

push {r4,r5}
	
	mov	  r4, r0
	mov 	r5,	r1
		
.keyPressed:

ldr   r0,=characterInf
ldrb  r1,[r0]

.upScroll:
    tst   r4,#KEY_UP
    beq   .downScroll     @ Up wasn't pressed
    cmp   r1,#0
    beq   .downScroll     @ we can't go out of screen
    sub   r1, #2
    b     .spritePos
    
.downScroll:
    tst   r4,#KEY_DOWN
    beq   .endUpdateKeys     @ Down wasn't pressed
    cmp   r1,#176
    beq   .endUpdateKeys     @ we can't go out of screen
    add   r1, #2
    b     .spritePos
   
.spritePos:
    ldr   r2,=OAM_A
    strb  r1, [r0]
    ldrh  r3,[r2]
    lsr   r3, #8
    orr   r3, r1, r3, lsl #8
    strh  r3, [r2]
    
.endUpdateKeys:
    pop {r4-r5}
bx lr

.global checkCollision

.align 2
.arm

checkCollision:

push {r4}

  ldr   r0,=characterInf
  ldr   r1,=scrollPos

  ldrb  r2, [r0]    @ spritey
  ldrh  r3, [r1]    @ bg x
  ldr   r0,=level0
  add   r3, r3, #16 @ spritewidth
  lsr   r3, #3          @ tilex
  ldr   r1, [r0, #16]   @ map pointer  
  tst   r2, #7          @ not aligned to a tile?
  lsr   r2, #3          @ tiley

  ldr   r0, [r0, #12]   @ mapwidth
  mla   r2, r0, r2, r3  @ tiley = tiley * width + tilex
  lsl   r2, r2, #1
  add   r1, r1, r2      @ add index *2 (hw) to pointer

  lsl   r0, r0, #1
  ldrh    r2,[r1], r0     @ load collision tile
  ldrh    r3,[r1], r0
  ldreqh  r4,[r1]
  orr   r2, r2, r3
  orreq r2, r2, r4
  cmp   r2, #0
  
  bne restart
  
  pop {r4}
bx lr; 

.arm
.align 2
.global restart

restart:
  push {lr}
  
  bl swiWaitforVblank
	bl readKeyReg
	tst r0,#KEY_A
	bne reset
	
	
  pop {lr}
b restart

.align 2
.thumb_func
.global reset
reset:

mov r0, #0
mov r1, r0